<?php
$db->exec("CREATE TABLE temp_table AS SELECT * FROM receiptlines");
$db->exec("DROP TABLE receiptlines");
$db->exec("CREATE TABLE receiptlines (id INTEGER PRIMARY KEY AUTOINCREMENT UNIQUE, receipt_id INT, product_id INT, product_title VARCHAR, price DOUBLE, price0 DOUBLE, vat INT, vat_type INT, count DOUBLE, discount INT, line_discount INT, description TEXT, loyalty INT DEFAULT (0), mark TEXT DEFAULT '', kitchen INT (1) DEFAULT (0), bar INT (1) DEFAULT (0), other_info TEXT DEFAULT '', parent_id INT DEFAULT (0), turn INT DEFAULT (1), create_order DOUBLE DEFAULT (0), complite_order DOUBLE DEFAULT (0), issued_order DOUBLE DEFAULT (0))");
$db->exec("INSERT INTO receiptlines (id, receipt_id, product_id, product_title, price, price0, vat, vat_type, count, discount, line_discount, description, loyalty, mark, kitchen, bar, other_info, parent_id, turn, create_order, complite_order, issued_order) SELECT id, receipt_id, product_id, product_title, price, price0, vat, vat_type, count, discount, line_discount, description, loyalty, mark, kitchen, bar, other_info, parent_id, turn, create_order, complite_order, issued_order FROM temp_table");
$db->exec("DROP TABLE temp_table");
$db->exec("CREATE INDEX line_product_id ON receiptlines (product_id)");
$db->exec("CREATE INDEX line_receipt_id ON receiptlines (receipt_id)");
$db->exec("CREATE INDEX line_parent_id ON receiptlines (parent_id)");
$db->exec("CREATE INDEX line_turn ON receiptlines (turn)");
