<?php
namespace Models;

class php_mspos_Fr_php {
	public $f3, $sets, $web, $config;

    protected $electronically=array(true, false);

	protected $ffd_version=array(
		1=>'1.0',
		2=>'1.05',
		3=>'1.1',
		4=>'1.2'
	),
	$fn_status=array(
		0=>'Настройка',
		1=>'Готов к фискализации',
		3=>'Фискальный режим',
		7=>'Фискальный режим закрыт, идёт передача ОФД',
		15=>'Чтение данных из архива ФН'
	),
	$ofd_status=array(
		0=>'Нет соединения',
		1=>'Транспортное соединение установлено',
		2=>'Есть сообщение для передачи ОФД',
		4=>'Ожидание ответного сообщения (квитанции) от ОФД',
		8=>'Есть команда от ОФД',
		16=>'Изменились настройки соединения с ОФД',
		32=>'Ожидание ответа на команду от ОФД'
	),
	$day_status=array(
		0=>'Смена закрыта',
		1=>'Смена открыта'
	),
	$pay_type=array(
		0=>'Наличные',
		1=>'Электронно'
	);

	public $fd=0; // Номер ФД
	public $fp=0; // Фискальный признак
	
	function __construct($f3, $sets, $config) {
		$this->f3=$f3;
		$this->sets=$sets;
		$this->web=\Web::instance();
        $this->config=$config;
        if(!isset($this->config['WaitTime'])) {
            $this->config['WaitTime']=30000;
        }
        if(!isset($this->config['FontSize'])) {
            $this->config['FontSize']=10;
        }
	}

    function get_mark_type($mark) {
        $strlen=mb_strlen($mark);
        if($strlen==68 && ctype_alnum($mark)) {
            return "egais20";
        }
        if($strlen==150 && ctype_alnum($mark)) {
            return "egais30";
        }

        return "other";
    }

	function kkm_init() {
		$this->f3->set('SESSION.'.$this->sets['printer'].'_drivers_init', 1);
	}

	// Формирование данных для отправки
	function options($uuid, $data, $timeout=3) {
		$options = array( // Данные для отправки на сервер
			'timeout'=>$timeout,
			'header'=>array(
				'Content-Type: application/json',
        		'Expect:'
			),
    		'method'  => 'POST',
    		'content'=>json_encode(
    			array(
    				'uuid'=>$uuid,
    				'request'=>$data
    			)
    		)
		);

		return $options;
	}

	// Отправка задания
	function send_task($options) {
		$url=$this->sets['url'].'/requests';
		$res=$this->web->request($url, $options);
		$json=json_decode($res['body'], true);
		if(mb_strpos($res['headers'][0], '200')===false && mb_strpos($res['headers'][0], '201')===false) {
			if(is_array($json) && $json['result']) {
				$error_txt='Код ошибки '.$json['result'][0]['error']['code'].'. '.$json['result'][0]['error']['description'];
			}
			elseif(is_array($json)) {
				$error_txt='Код ошибки '.$json['error']['code'].'. '.$json['error']['description'];
			}
			else {
				$error_txt=$res['body'];
			}
			if($this->f3->get('fr_error_ignore')) {
                return array(
                    'success'=>false,
					'error'=>$error_txt
                );
            }
            echo $error_txt;
			exit();
		}
		return $res;
	}

	function check_task($uuid) {
		$url=$this->sets['url'].'/requests/'.$uuid;
		$options=array(
			'timeout'=>3,
			'method'=>'GET'
		);
		// Ждем выполнения задания
		$ok=false;
		$error='';
		$n=200;
		for($i=0; $i<$n; $i++) {
			usleep($this->config['WaitTime']);
			$res=$this->web->request($url, $options);
			$json=json_decode($res['body'], true);
			if(mb_strpos($res['headers'][0], '200')===false && mb_strpos($res['headers'][0], '201')===false) {
				if(is_array($json) && $json['result']) {
					$error_txt='Код ошибки '.$json['result'][0]['error']['code'].'. '.$json['result'][0]['error']['description'];
				}
				elseif(is_array($json)) {
					$error_txt='Код ошибки '.$json['error']['code'].'. '.$json['error']['description'];
				}
				else {
					$error_txt=$res['body'];
				}
				if($this->f3->get('fr_error_ignore')) {
	                return array(
	                    'success'=>false,
						'error'=>$error_txt
	                );
	            }
	            echo $error_txt;
	            $this->send_ajax('g;');
				exit();
			}
			// Проверяем результаты заданий
			$ready=0;
			$wait=1;
			foreach ($json['results'] as $r) {
				if($r['status']=='ready') { // Задание выполнено
					$ready=1;
					$wait=0;
					if($r['error']['code']>0) {
						$ok=false;
					}
					
					
				}
				if($r['status']=='wait' || $r['status']=='inProgress') { // Задание ждет очереди или еще выполняется
					$ready=0;
				}
				if($r['status']=='error') { // Ошибка выполнения задания, дальше ничего не выполнится
                    echo '<p class="false">'.$r['error']['description'].'</p>';
					$i=$n;
					$ready=0;
					$wait=0;
					break;
				}
			}
			if($ready==1) {
				$i=$n;
				$ok=true;
			}
		}
		if($wait==1) {
			$ok=false;
			$json['results'][0]['error']['code']=9999;
			$json['results'][0]['error']['description']='Не удалось дождаться выполнения задания ';
		}
		if($ok===false) { // Вывод ошибок
			$this->send_ajax('g;');
			foreach ($json['results'] as $a=>$r) {
				$error.='<p class="false">Код ошибки '.$r['error']['code'].'. '.$r['error']['description'].'</p>';
			}
		}
		return array(
			'success'=>$ok,
			'error'=>$error,
			'results'=>$json['results']
		);
	}

	// Выводим статус ККМ в понятном виде
	function deviceStatus($data) {
		$txt=array(
			'group_1'=>'Статус ККТ',
			'GetRegNum'=>'Регистрационный номер ККТ',
			'GetSerial'=>'Заводской номер ККТ (ЗН)',
			'GetAppVersion'=>'Версия ПО ядра',
			'GetTaxId'=>'ИНН, указанный при регистрации',
			'GetKKTRegisteredName'=>'Название ККТ в реестре',
			'group_2'=>'Запрос сменных счётчиков по типам документов и оплат',
			'group_3'=>'Документы продажи',
			'GetDayPayTotalByDocType_1_5'=>'Наличные',
			'GetDayPayTotalByDocType_1_6'=>'Электронно',
			'group_4'=>'Документы возврата продажи',
			'GetDayPayTotalByDocType_2_5'=>'Наличные',
			'GetDayPayTotalByDocType_2_6'=>'Электронно',
			'group_5'=>'',
			'GetFiscalMemoryFiscalized'=>'Статус фискализации ККТ в фискальной памяти (ФП)',
			'group_6'=>'Запрос счётчиков накоплений на начало смены по типу счётчика',
			'GetGrandTotalsSalesGross_1'=>'Документы продажи',
			'GetGrandTotalsSalesGross_2'=>'Документы возврата продажи',
			'group_7'=>'',
			'GetCurrentFfdVersion'=>'Версия ФФД',
			'GetKktVersion'=>'Версия модели',
			'GetKktFfdVersion'=>'Максимальная версия ФФД поддерживаемая ККТ',
			'group_8'=>'Статус ФН',
			'FNGetNumber'=>'Номер ФН',
			'FNGetState'=>'Состояние ФН',
			'FNGetCurrentDocType'=>'Текущий документа из ФН',
			'FNGetLastDocDateTime'=>'Дата и время последнего фискального документа',
			'FNGetSoftwareVersion'=>'Версия ПО ФН',
			'FNGetFirmwareType'=>'Тип ПО ФН',
			'FNGetLastFDNumber'=>'Номер последнего фискального документа',
			'FNGetLifetime'=>'Дата и время окончания действия ФН',
			'FNGetRegistrationsLeft'=>'Количество оставшихся регистраций ФН',
			'FNGetRegistrationsMade'=>'Количество выполненных регистраций ФН',
			'FNGetRegTimeFirst'=>'Время первой регистрации (фискализации) ФН',
			'FNGetLastFiscalSign'=>'ФП последнего фискального документа',
			'FNGetFnFfdVersion'=>'Код версии ФФД, которую может поддерживать ФН',
			'group_9'=>'Состояние ОФД',
			'OFDGetConnectionStatus'=>'Состояние соединения с ОФД',
			'OFDGetQueuedMessagesCount'=>'Количество документов, ожидающих отправки в ОФД',
			'OFDGetFirstQueuedDocNumber'=>'Номер документа, находящегося первым в очереди на отправку в ОФД',
			'OFDGetLastNotSentDocTime'=>'Дата последнего непереданного в ОФД документа',
			'group_10'=>'Состояние смены',
			'GetDayState'=>'Состояние смены в ККТ',
			'GetDayNumber'=>'Номер смены',
			'GetDayLastReceiptNumber'=>'Номер последнего документа в смене'
		);
		foreach($txt as $key=>$title) {
			if(!isset($data[$key])) {
				echo '<h1>'.$title.'</h1>';
			}
			else {
				if($key=='GetFiscalMemoryFiscalized') {
					if($data[$key]) {
						$data[$key]='фискальная память фискализирована';
					}
					else {
						$data[$key]='фискальная память не фискализирована';
					}
				}
				elseif($key=='GetCurrentFfdVersion' || $key=='GetKktFfdVersion' || $key=='FNGetFnFfdVersion') {
					$data[$key]=$this->ffd_version[$data[$key]];
				}
				elseif($key=='FNGetState') {
					$data[$key]=$this->fn_status[hexdec($data[$key])];
				}
				elseif($key=='OFDGetConnectionStatus') {
					$data[$key]=$this->ofd_status[hexdec($data[$key])];
				}
				elseif($key=='GetDayState') {
					$data[$key]=$this->day_status[hexdec($data[$key])];
				}
				echo '<p><b>'.$title.'</b>: '.$data[$key].'</p>';
			}
		}
	}

	// Отправка запроса
	function send_ajax($strs, $timeout=3, $view=false) {
		if(!$this->f3->get('SESSION.'.$this->sets['printer'].'_drivers_init')) {
			$this->kkm_init();
		}
		$data=$this->wtf($strs);
		if(!$data) {
			echo '<p class="false">'.$strs.'<br>Команда не поддерживается</p>';
			exit();
		}

		$uuid=uniqid(); // id задания
		$options = $this->options($uuid, $data);
		// Отправляем запрос
		$res=$this->send_task($options);
		// Проверка выполнения задания
		$res=$this->check_task($uuid);
		if(!$res['success']) {
			echo $strs.'<br>';
			echo $res['error'];
			exit();
		}
		
		if($view) {
			foreach ($res['results'] as $key=>$r) {
				if($DeviceInfo) {
					$this->deviceStatus($DeviceInfo);
				}
				elseif($r['result']) {
					if($r['error']['code']) {
						echo '<p class="false">'.$r['error']['description'].'</p>';
					}
					else {
						echo '<p class="true">Выполнено успешно</p>';
					}
				}
			}
		}
		if(!$res['success'] && !$view) {
			echo $continue_html= \Template::instance()->render('fr_error.htm');
			exit();
		}

		if($this->fd!=0 && $this->fp!=0) {
			$res['fd']=$this->fd;
			$res['fp']=$this->fp;
		}

		return $res;
	}

	// Информация о ККМ
	function getDeviceInfo() {
		$data=array(
			array('GetRegNum'),
			array('GetSerial'),
			array('GetAppVersion'),
			array('GetTaxId'),
			array('GetKKTRegisteredName'),
			array('GetDayPayTotalByDocType', 1, 5),
			array('GetDayPayTotalByDocType', 1, 6),
			array('GetDayPayTotalByDocType', 2, 5),
			array('GetDayPayTotalByDocType', 2, 6),
			array('GetFiscalMemoryFiscalized'),
			array('GetGrandTotalsSalesGross', 1),
			array('GetGrandTotalsSalesGross', 2),
			array('GetCurrentFfdVersion'),
			array('GetKktVersion'),
			array('GetKktFfdVersion'),
			array('FNGetNumber'),
			array('FNGetState'),
			array('FNGetCurrentDocType'),
			array('FNGetLastDocDateTime'),
			array('FNGetSoftwareVersion'),
			array('FNGetFirmwareType'),
			array('FNGetLastFDNumber'),
			array('FNGetLifetime'),
			array('FNGetRegistrationsLeft'),
			array('FNGetRegistrationsMade'),
			array('FNGetRegTimeFirst'),
			array('FNGetLastFiscalSign'),
			array('FNGetFnFfdVersion'),
			array('OFDGetConnectionStatus'),
			array('OFDGetQueuedMessagesCount'),
			array('OFDGetFirstQueuedDocNumber'),
			array('OFDGetLastNotSentDocTime'),
			array('GetDayState'),
			array('GetDayNumber'),
			array('GetDayLastReceiptNumber'),
		);
		$uuid=uniqid(); // id задания
		$options = $this->options($uuid, $data, 10);
		// Отправляем запрос
		$res=$this->send_task($options);
		// Проверка выполнения задания
		$res=$this->check_task($uuid);
		if(!$res['success']) {
			echo $res['error'];
			exit();
		}
		$result=array();
		foreach($res['results'][0]['result'] as $n=>$r) {
			$key=$data[$n][0];
			if(isset($data[$n][1])) {
				$key.='_'.$data[$n][1];
			}
			if(isset($data[$n][2])) {
				$key.='_'.$data[$n][2];
			}
			$result[$key]=$r;
		}
		return $result;
	}

    // Узнаем состояние смены
    function change_status() {
        $data[0]=array(
            'type'=>'getShiftStatus'
        );
        $uuid=uniqid(); // id задания
        $options = $this->options($uuid, $data);
        // Отправляем запрос
        $res=$this->send_task($options);
        // Проверка выполнения задания
        $res=$this->check_task($uuid);
        if(!$res['success']) {
            echo $res['error'];
            exit();
        }
        $status=$res['results'][0]['result']['shiftStatus']['state'];
        // closed - закрыта
        // opened - открыта
        // expired - истекла
        return $status;
    }

	// Узнать ширину бумаги
	function get_width() {
		if(!$this->config['PaperWidth']) $this->config['PaperWidth']=32;
		return $this->config['PaperWidth'];
	}

	// Форматирование текста
    function text_format($str) {
    	$lines=array();
    	$str=str_replace('#kkm_br##kkm_right#', '#kkm_right#', $str);
    	$str=str_replace('#kkm_br##kkm_center#', '#kkm_center#', $str);
    	$str=str_replace('#kkm_right#', '#kkm_br##kkm_right#', $str);
    	$str=str_replace('#kkm_center#', '#kkm_br##kkm_center#', $str);
    	$strs=explode('#kkm_br#', $str);
    	foreach($strs as $s) {
    		$bold=0;
    		$align=0;
    		if(mb_strpos($s, '#kkm_bold')!==false) {
    			$bold=1;
    			$s=str_replace('#kkm_bold#', '', $s);
    			$lines[]=array(
        			'SetFont',
        			$this->config['FontSize']*2
        		);
    		}
    		if(mb_strpos($s, '#kkm_center')!==false) {
    			$align=1;
    			$s=str_replace('#kkm_center#', '', $s);
    		}
    		elseif(mb_strpos($s, '#kkm_right')!==false) {
    			$align=2;
    			$s=str_replace('#kkm_right#', '', $s);
    		}
    		$lines[]=array(
				'PrintLine',
				$align,
        		$s
        	);
        	if($bold==1) {
        		$lines[]=array(
        			'SetFont',
        			$this->config['FontSize']
        		);
        	}
    	}

    	return $lines;
    }

    function get_1162($pg, $mark) {
        if($pg=='pharma') $pg='medicines';
        $data[0]=array(
            "type"=>$pg
        );
        if($pg=='furs') {
            $data['serial']=$mark;
        }
        elseif($pg=='tobacco') {
            $data['gtin']=mb_substr($mark, 0, 14);
            $data['serial']=mb_substr($mark, 14, 7);
        }
        else {
            $data['gtin']=mb_substr($mark, 2, 14);
            $data['serial']=mb_substr($mark, 18, 13);
        }
        return $data;
    }

	// Что надо выполнить
	function wtf($strs) {
		$str=explode("\n", $strs);
		$open=false;
		$correct_data=array(
			'AddCorrectionRecItem1_1',
        	-1,
        	'',
        	''
        );
		$data[]=array(
        	'SetFont',
        	$this->config['FontSize']
        );
        $clearmark=false;
		foreach ($str as $s) {
			$items=array();
			$s=trim($s);
        	$p=explode(';', $s);
        	$n=count($p);
        	if($p[$n-1]=='') {
            	unset($p[$n-1]);
            	$n-=1;
        	}
        	if($s=='') continue;
        	if($p[0]=='beep') { // Гудок
        		if(!$open) {
        			$open=true;
        			$data[]=array(
        				'OpenRec',
        				9
        			);
        		}
        		$data[]=array(
        			'PrintLine',
        			0,
        			'Бип-бип-бип! Твой сигналит джип'
        		);
        	}
        	elseif($p[0]=='feed') { // Протяжка
        		if(!$open) {
        			$open=true;
	        		$data[]=array(
	        			'OpenRec',
	        			9
	        		);
	        	}
                $data[]=array(
                    'Feed',
                    $p[1]
                );
        	}
        	elseif($p[0]=='g') {
        		$data[]=array(
        			'RecVoid'
        		);
        	}
        	elseif($p[0]=='open_session') { // Открытие смены
        		if($open) {
        			$open=false;
        			$data[]=array(
        				'CloseRec'
        			);
        		}
        		$cashier_name='';
        		if(isset($p[2])) {
        			$cashier=explode('{{user_inn}}', $p[2]);
        			$cashier_name=$cashier[0];
        		}
        		$data[]=array(
        			'OpenDay',
        			$cashier_name
        		);
        	}
        	elseif($p[0]=='z') { // Закрытие смены
        		if($open) {
        			$open=false;
        			$data[]=array(
        				'CloseRec'
        			);
        		}
                $cashier_name='';
        		if(isset($p[2])) {
        			$cashier=explode('{{user_inn}}', $p[2]);
        			$cashier_name=$cashier[0];
        		}
        		$data[]=array(
        			'CloseDay',
        			$cashier_name
        		);
        	}
        	elseif ($p[0]=='p' || $p[0]=='pm') { // Печать текста
        		if(!$open) {
        			$open=true;
        			$data[]=array(
        				'OpenRec',
        				9
        			);
        		}
        		$data=array_merge($data, $this->text_format($p[1]));
        	}
            elseif ($p[0]=='qr') { // Печать текста

                $data[]=array(
                	'PrintQRCode',
                	$p[1],
                	1
                );
            }
        	elseif($p[0]=='print_font') { // Печать строки заданным размером шрифта
        		if(!$open) {
        			$open=true;
        			$data[]=array(
        				'OpenRec',
        				9
        			);
        		}
        		$data[]=array(
        			'SetFont',
        			$p[1]
        		);
        		$data=array_merge($data, $this->text_format($p[2]));
        		$data[]=array(
        			'SetFont',
        			$this->config['FontSize']
        		);
        	}
        	elseif($p[0]=='print_bold') { // Печать жирной строки
        		if(!$open) {
        			$open=true;
        			$data[]=array(
        				'OpenRec',
        				9
        			);
        		}
        		$data[]=array(
        			'SetFont',
        			$this->config['FontSize']*2
        		);
        		$data=array_merge($data, $this->text_format($p[1]));
        		$data[]=array(
        			'SetFont',
        			$this->config['FontSize']
        		);
        	}
        	elseif($p[0]=='x') { // X отчет
        		if($open) {
        			$open=false;
        			$data[]=array(
        				'CloseRec'
        			);
        		}
        		$data[]=array(
        			'PrintCalculationsReport'
        		);
        	}
        	elseif($p[0]=='continue_print') { // Продолжить печать чека
        		$data[]=array(
        			'RecVoid'
        		);
        	}
        	elseif($p[0]=='c') { // Печать копии последнего чека
        		if($open) {
        			$open=false;
        			$data[]=array(
        				'CloseRec'
        			);
        		}
        		$data[]=array(
        			'PrintRecCopy'
        		);
        	}
        	elseif($p[0]=='d') { // Статус ККМ
            	$this->deviceStatus($this->getDeviceInfo());
            	exit();
        	}
        	elseif($p[0]=='imde') { // Внесение или изъятие из кассы
        		$type=7;
        		if($p[1]<0)$type=8;
        		if($open) {
        			$open=false;
        			$data[]=array(
        				'CloseRec'
        			);
        		}
        		$data[]=array(
        			'OpenRec',
        			$type
        		);
        		$data[]=array(
        			'PrintRecItem',
        			1,
        			number_format($p[1]/100, 2, '.', ''),
        			'Внесение/Изъятие',
        			' '
        		);
        		$data[]=array(
        			'PrintRecTotal'
        		);
        		$data[]=array(
        			'PrintRecItemPay',
        			0,
        			number_format($p[1]/100, 2, '.', ''),
        			$this->pay_type[0]
        		);
        		$data[]=array(
        			'CloseRec'
        		);
        	}
        	elseif($p[0]=='b') { // Открытие чека
        		if($open) {
        			$data[]=array(
        				'CloseRec'
        			);
        		}
        		$cashier=explode('{{user_inn}}', $p[2]);
        		if($cashier[0]) {
        			$data[]=array(
        				'SetUserName',
        				$cashier[0]
        			);
        		}

        		$types=array(0=>1, 1=>3, 128=>19, 130=>19);
        		$data[]=array(
        			'OpenRec',
        			$types[$p[1]]
        		);
        		if($types[$p[1]]==19) {
        			$correct=true;
        		}
        		$open=true;
        	}
        	elseif($p[0]=='set_tlv' && $p[1]==1173 && $open===true) { // Тип коррекции
        		$correct_data[1]=$p[3];
        	}
        	elseif($p[0]=='set_tlv' && $p[1]==1178 && $open===true) { // Дата коррекции
        		$correct_data[2]=date('Y.m.d', $p[3]).'T'.date('H:i:m:s', $p[3]);
        	}
        	elseif($p[0]=='set_tlv' && $p[1]==1179 && $open===true) { // Номер документа коррекции
        		$correct_data[3]=(string)$p[3];
        	}
        	elseif($p[0]=='set_tlv' && $p[1]==1008 && $open===true) { // Добавление в чек покупателя
        		if(mb_strpos($p[3], '@')>0) {
        			$data[]=array(
        				'SetSenderEmail',
        				$p[3]
        			);
        		}
        		else {
        			$p[3]='+'.$p[3];
        		}
        		$data[]=array(
        			'SendClientAddress',
        			$p[3]
        		);
        	}
        	elseif($p[0]=='smde' && $open===true) { // Добавление товара в чек

                $p_name=explode('{{marking}}', $p[1]);
        		if(!$p[6])$p[6]=1;
        		if(!$p[7])$p[7]=1;
        		$p[2]/=100;
        		$p[3]/=1000;

        		$data[]=array(
        			'SetItemTaxes',
        			$p[4]
        		);

        		$data[]=array(
        			'PrintRecItem',
        			number_format($p[3], 3, '.', ''),
        			number_format($p[2], 2, '.', ''),
        			$p_name[0],
        			' '
        		);

        		// Маркировка
                /*if(count($p_name)>1) {
                	$mark=str_replace('{{U+003B}}', ';', $p_name[1]);
                    if($this->sets['version']=='1.2') {
                    	$clearmark=true;
                    	$this->send_ajax('check_mark;'.$p_name[1]);
                    	$this_item['imcParams']=array(
							"imcType"=>'auto',
							"imc"=>base64_encode($mark),
							"itemEstimatedStatus"=>"itemDryForSale",
            				"imcModeProcessing"=>0,
            				'itemInfoCheckResult'=>array(
							    "ecrStandAloneFlag"=>true,
							    "imcCheckFlag"=>true,
							    "imcCheckResult"=>true,
							    "imcEstimatedStatusCorrect"=>true,
							    "imcStatusInfo"=>true
            				)
						);
                    }
                    else {
                    	if(isset($p_name[2]) && ($p_name[2]=='furs' || $p_name[2]=='pharma' || $p_name[2]=='tobacco' || $p_name[2]=='shoes')) {
                        	$mark=str_replace('', '', $mark);
                        	$mark=str_replace('\\u001d', '', $mark);
	                        $this_item['nomenclatureCode']=$this->get_1162($p_name[2], $mark);
	                    }
	                    else {
	                        $mlen=mb_strlen($mark);
	                        if($mlen!=8
	                            && $mlen!=13
	                            && $mlen!=14
	                            && preg_match("/[A-Za-z0-9\/\\!”%&’()*+-.,:;=<>?]/", $mark)
	                            && mb_substr($mark, 0, 2)=='01'
	                            && mb_substr($mark, 16, 2)=='21') {
	                            $mark=str_replace('', '\\u001d', $mark);
	                            if(mb_strpos($mark, '\\u001d')===false) {  
	                                $mark='\\u001d'.mb_substr($mark, 0, 31).'\\u001d'.mb_substr($mark, 31, 6).'\\u001d'.mb_substr($mark, 37);
	                            }
	                        }
	                        $this_item['markingCode']=array(
	                            "type"=>$this->get_mark_type($p_name[1]),
	                            "mark"=>base64_encode($mark)
	                        );
	                    }
	                }
                }*/
        	}
        	elseif($p[0]=='tmde' && $open===true) { // Оплата чека
        		$data[]=array(
        			'PrintRecTotal'
        		);
        		if(count($p)==3) { // передан 1 способ оплаты ФФД 1.05
        			$data[]=array(
        				'PrintRecItemPay',
        				$p[2],
        				number_format($p[1]/100, 2, '.', ''),
        				$this->pay_type[$p[2]]
        			);
        		}
        		else { // Несколько способов оплаты
        			if(count($p)==7) $end=4;
        			else $end=5;
        			for($j=0; $j<$end; $j++) {
        				if(isset($this->pay_type[$j]) && $p[$j+1]>0) {
        					$data[]=array(
	        					'PrintRecItemPay',
        						(string)$j,
        						number_format($p[$j+1]/100, 2, '.', ''),
        						$this->pay_type[$j]
        					);
        				}
        			}
        		}
        		$data[]=array(
        			'PrintLine',
        			0,
        			' '
        		);

        		$data[]=array(
        			'PrintLine',
        			0,
        			'Итого оплачено'
        		);

        		// Маркировка
        		/*if($this->sets['version']=='1.2' && $clearmark===true) {
        			$i++;
        			$data[$i]=array(
        				'type'=>'clearMarkingCodeValidationResult'
        			);
        		}*/
        	}
        	elseif($p[0]=='open_cash_box') { // открыть денежный ящик
        		$data[$i]=array(
        			'type'=>'openCashDrawer'
        		);
        	}
        	elseif($p[0]=='check_mark') {
        		/*$data[$i]=array(
        			'type'=>'cancelMarkingCodeValidation'
        		);
        		$i++;*/
        		$data[$i]=array(
        			'type'=>'beginMarkingCodeValidation',
        			"params"=>array(
        				"imcType"=>"auto",
        				"imc"=>base64_encode(str_replace('{{U+003B}}', ';', $p[1])),
        				"itemEstimatedStatus"=>"itemDryForSale",
        				"imcModeProcessing"=>0,
        				"itemQuantity"=>1,
    					"itemUnits"=>"piece"
    				)
        		);
        		/*$i++;
        		$data[$i]=array(
        			'type'=>'getMarkingCodeValidationStatus'
        		);*/
        	}
        }
        if($correct_data[1]>=0) {
        	$data[]=$correct_data;
        }
        if($open) {
        	$open=false;
        	$data[]=array(
        		'CloseRec'
        	);
        }
        return $data;
	}
}
